// MyThread.cpp : implementation file
//

#include "stdafx.h"
#include "ThreadMsg.h"
#include "MyThread.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMyThread

IMPLEMENT_DYNCREATE(CMyThread, CWinThread)

CMyThread::CMyThread(AFX_THREADPROC pProc, void *pP):CWinThread(pProc,pP)
{
     m_bAutoDelete = FALSE;
     m_ShutdownEvent = ::CreateEvent(NULL,   // security
                                   TRUE,   // manual-reset
                                   FALSE,  // not signaled
                                   NULL);  // anonymous

     m_PauseEvent = ::CreateEvent(NULL,      // security
                                TRUE,      // manual-reset
                                TRUE,      // signaled
                                NULL);     // anonymouse
	this->m_NwaitObjs = 0;
	memset(this->m_WaitObjects,0,sizeof(HANDLE) * 16);
	this->m_MSGQ = 0;
}

CMyThread::~CMyThread()
{
	::CloseHandle(m_PauseEvent);
	::CloseHandle(m_ShutdownEvent);
}

BOOL CMyThread::InitInstance()
{
	// TODO:  perform and per-thread initialization here
	return TRUE;
}

int CMyThread::ExitInstance()
{
	// TODO:  perform any per-thread cleanup here
	return CWinThread::ExitInstance();
}

BEGIN_MESSAGE_MAP(CMyThread, CWinThread)
	//{{AFX_MSG_MAP(CMyThread)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMyThread message handlers

CMyThread * CMyThread::BeginThread(AFX_THREADPROC pProc, void *pP,int MsgQDepth)
{
    CMyThread * thread = new CMyThread(pProc, pP);
    if(!thread->CreateThread(CREATE_SUSPENDED,0 ))
 //   if(!thread->CreateThread())
    { /* failed */
       delete thread;
       thread = 0;
    } /* failed */
	else
	{
		//-----------------------------
		// setup default wait objects
		//-----------------------------
		thread->SetWaitObject(thread->m_ShutdownEvent,MT_SHUTDOWN);
		thread->SetWaitObject(thread->m_PauseEvent,MT_RUNNING);
		thread->m_MSGQ = new CMsgQueue(MsgQDepth);
		thread->SetWaitObject(thread->m_MSGQ->GetSem()->GetHandle(),MT_MESSAGE);
	}
    return thread;
}

void CMyThread::ShutDown()
{
	SetEvent(m_ShutdownEvent);
	::WaitForSingleObject(m_hThread, INFINITE);
}

DWORD CMyThread::Wait()
{
    DWORD result = ::WaitForMultipleObjects(this->m_NwaitObjs, this->m_WaitObjects, FALSE, INFINITE);

    switch(result)
    { /* result */
       case WAIT_TIMEOUT:
           result =  MT_TIMEOUT;
		   break;
       default:
          if(result <= WAIT_OBJECT_0+16)
		   {
			   result = m_WaitRetVals[result - WAIT_OBJECT_0];
		   }
		   else
			result =  MT_ERROR;
		   break;
	} /* result */
	return result;
 }

void CMyThread::Pause()
{
	ResetEvent(m_PauseEvent);
}

void CMyThread::Continue()
{
	SetEvent(this->m_PauseEvent);
}


int CMyThread::SetWaitObject(HANDLE hObj, DWORD RetVal)
{
	int rV = 1;
	if(m_NwaitObjs < 16)
	{
		m_WaitObjects[m_NwaitObjs] = hObj;
		this->m_WaitRetVals[m_NwaitObjs++] = RetVal;
		rV = 0;
	}
	return rV;
}

void CMyThread::ClearWaitObjects()
{
	memset(this->m_WaitObjects,0,sizeof(HANDLE) * 16);
	this->m_NwaitObjs = 0;
}
