// ThreadMsgView.cpp : implementation of the CThreadMsgView class
//

#include "stdafx.h"
#include "ThreadMsg.h"

#include "ThreadMsgDoc.h"
#include "ThreadMsgView.h"
#include "Messages.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "SendMessageDlg.h"
#include "MSG.h"

/////////////////////////////////////////////////////////////////////////////
// CThreadMsgView

IMPLEMENT_DYNCREATE(CThreadMsgView, CView)

BEGIN_MESSAGE_MAP(CThreadMsgView, CView)
	//{{AFX_MSG_MAP(CThreadMsgView)
	ON_COMMAND(ID_MENU_EDIT_STARTTHREAD, OnMenuEditStartthread)
	ON_COMMAND(ID_MENU_KILL_THREAD, OnMenuKillThread)
	ON_COMMAND(ID_MENU_EDIT_DISPCNT, OnMenuEditDispcnt)
	ON_COMMAND(ID_MENU_EDIT_CONT, OnMenuEditCont)
	ON_COMMAND(ID_MENU_EDIT_PAUSE, OnMenuEditPause)
	ON_COMMAND(ID_MENU_EDIT_SENDMESSAGE, OnMenuEditSendmessage)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_THREAD,OnThrdMsg)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CThreadMsgView construction/destruction

CThreadMsgView::CThreadMsgView()
{
	// TODO: add construction code here
	m_Count = 0;
	m_pLine1 = new char[256];
	m_pLine2 = new char[256];
	*m_pLine1 = 0;
	*m_pLine2 = 0;
}

CThreadMsgView::~CThreadMsgView()
{
	delete[] m_pLine1;
	delete[] m_pLine2;
}

BOOL CThreadMsgView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CThreadMsgView drawing

void CThreadMsgView::OnDraw(CDC* pDC)
{
	CThreadMsgDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
	CRect CR;
	GetClientRect(&CR);
	CR.bottom = CR.top + 16;
	pDC->DrawText(m_pLine2,strlen(m_pLine2),&CR,DT_LEFT);
	CR.top += 16;
	CR.bottom += 16;
	pDC->DrawText(m_pLine1,strlen(m_pLine1),&CR,DT_LEFT);
}

/////////////////////////////////////////////////////////////////////////////
// CThreadMsgView diagnostics

#ifdef _DEBUG
void CThreadMsgView::AssertValid() const
{
	CView::AssertValid();
}

void CThreadMsgView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CThreadMsgDoc* CThreadMsgView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CThreadMsgDoc)));
	return (CThreadMsgDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CThreadMsgView message handlers


UINT Worker(void *params)
{
	int loop = 1;
	DWORD E;
	int count = 0;
	AMSG *pMsg;

	CThreadMsgView *pTMV = (CThreadMsgView *)params;
	while(loop)
	{
		E = pTMV->pThread->Wait();
		if(E == MT_SHUTDOWN)
			loop = 0;
		if(E == MT_MESSAGE)
		{
			++count;
			pMsg = pTMV->pThread->m_MSGQ->Remove();
			pTMV->PostMessage(pMsg->ReplyCmd,pMsg->MsgCmd,count);
			DeleteAMSG(pMsg);
		}
		pTMV->m_Count++;
	}
	return 0;
}

void CThreadMsgView::OnMenuEditStartthread() 
{
	// TODO: Add your command handler code here
	pThread = CMyThread::BeginThread(Worker,this,16);
	if(pThread)	pThread->ResumeThread();
	else
		MessageBox("Thread did not start","ERROR");
}

void CThreadMsgView::OnMenuKillThread() 
{
	// TODO: Add your command handler code here
	this->pThread->ShutDown();
}

void CThreadMsgView::OnMenuEditDispcnt() 
{
	// TODO: Add your command handler code here
	sprintf(m_pLine2,"%d",m_Count);
	Invalidate();
}

void CThreadMsgView::OnMenuEditCont() 
{
	// TODO: Add your command handler code here
	pThread->Continue();
}

void CThreadMsgView::OnMenuEditPause() 
{
	// TODO: Add your command handler code here
	pThread->Pause();
}

LRESULT CThreadMsgView::OnThrdMsg(WPARAM wP, LPARAM lP)
{
	sprintf(m_pLine1,"CMD:%d  COUNT:%d",wP,lP);
	Invalidate();
	return 0;
}

void CThreadMsgView::OnMenuEditSendmessage() 
{
	// TODO: Add your command handler code here
	AMSG *pMsg;

	CSendMessageDlg Dlg;

	Dlg.DoModal();
	pMsg = CreateAMSG(0,NULL,Dlg.m_msg);
	pMsg->ReplyCmd = WM_THREAD;
	this->pThread->m_MSGQ->Insert(pMsg);
}
